/****************************************************************************
 * WHAM windowing system for Allegro & DJGPP                                *
 * Copyright 1997 Martijn Versteegh                                         *
 * WHAM is swapware                                                         *
 * that means if you use it you must send me something in return            *
 * If you use WHAM in a commercial product, 'something' should preferrable  *
 * be money. A program you made, a postcard or something like that will do  *
 * in most other cases.                                                     *
 *  for contact info see contact.txt in the dcos directory.                 *
 *                                                                          *
 *  Disclaimer:                                                             *
 *      I am not responsible for any effect this software may have on you,  *
 *      your properties or anything else connected to you.                  *
 *      Use it at your own risk.                                            *
 ****************************************************************************/
#ifndef _Wham_guicon_h_
#define _Wham_guicon_h_

#include "window.h"
#define  GUICON_MAGIC_NUMBER  1
#define RAISE_IMMEDIATE       1
#define RAISE_CLICK           2

typedef int (*GUIPROCTYPE)(int msg, DIALOG *d, int c);

class AlGuiContainer : public Window
{

  public:
//	  friend void AlGuiContainer_dclick_check(...);
	  // constructor
	  AlGuiContainer(int size_x,int size_y,int pos_x,int pos_y,char *name,DIALOG *d, int syspriority = FALSE);
	  AlGuiContainer(int size_x,int size_y,int pos_x,int pos_y,char *name,DIALOG *d, int (*draw_border)(BITMAP *onto,Wobject *the_object,int from_x,int from_y,int to_x,int to_y),int syspriority = FALSE);

	  ~AlGuiContainer();

     //put another dialog in an existing window (the original will be returned)
     DIALOG *change_dialog(DIALOG *d);
     // get a pointer to the internal dialog
     DIALOG const *get_dialog() const;
     
     // redraw the dialog
	  void redraw();
	  void redraw(int fg_color, int bg_color);


     //get the object that closed the dialog
	  int get_closer_object();

	  //start the dialog
	  void start(int focus_obj = -1);
	  //stop the  dialog
	  void stop();

     // request winsys to delete it when it stops running
     int delete_when_done;

	  //is it still busy?
	  int is_running();

     
	  static int Border_Color;
	  static int Title_Color;
	  static int Refresh_Rate; //obsolete
     FONT *algui_font;
     
	  int process_keyboard();   // virtual
	  Wobject *process_mouse(int *x = NULL, int *y = NULL);
	  int process_message(Wobject *from, int message);


     // switches the 'screen' pointer to the hw screen and back to the
     // window's space *only* for use in dialog procedures
     // more or less obsolete now
     static void push_gui_screen();
     static void pop_gui_screen();


     int in_proc;
  private:
  		void shutdown();
  		void create(DIALOG *d, int syspriority);
      void destroy();
	   static int g_mouse_x();
	   static int g_mouse_y();
	   static int nr_of_instances;
	   int do_dialog(DIALOG_PLAYER *dp);
	   int
			focus_obj,
			it_is_running,
			res,
			obj,
			mouse_obj,
			ox,
			oy,
			joy_on;

		long
			ch;

		DIALOG
			*dialog;

		  DIALOG_PLAYER *diaplayer;

     int syspriority;
     int in_changing;
     
	  static int d_proc(int msg,DIALOG *d, int c);
	  static int draw_border(BITMAP *onto, Wobject *the_object,int from_x, int from_y, int to_x, int to_y);


		int dialog_size;
      GUIPROCTYPE *original_procs;
      static AlGuiContainer *current_guicon;
		static AlGuiContainer **guicon_list;
		static int guicon_list_size;
		static int max_guicon_list_size;
		static void register_guicontainer(AlGuiContainer *guicon);
		static void unregister_guicontainer(AlGuiContainer *guicon);
		static GUIPROCTYPE find_proc_for_dialog(DIALOG *d, AlGuiContainer **obj);
     
   protected:

};

extern int whamgui_raise_style;

#endif // end of headerfile
