/****************************************************************************
 * WHAM windowing system for Allegro & DJGPP                                *
 * Copyright 1997 Martijn Versteegh                                         *
 * WHAM is swapware                                                         *
 * that means if you use it you must send me something in return            *
 * If you use WHAM in a commercial product, 'something' should preferrable  *
 * be money. A program you made, a postcard or something like that will do  *
 * in most other cases.                                                     *
 *  for contact info see contact.txt in the docs directory.                 *
 *                                                                          *
 *  Disclaimer:                                                             *
 *      I am not responsible for any effect this software may have on you,  *
 *      your properties or anything else connected to you.                  *
 *      Use it at your own risk.                                            *
 ****************************************************************************/
#ifndef _Wham_backgrnd_h_
#define _Wham_backgrnd_h_

#include <helpers.h>
#include <wobject.h>

#define BACKGROUND_MODE_STRETCH 1
#define BACKGROUND_MODE_TILE    2
#define BACKGROUND_MODE_CENTER  4
#define BACKGROUND_MODE_MASKED  8

class Background : public Wobject
{

  public:

      Background(BITMAP *bmp,int mode);
      Background(int color); // solid color background
      // this function handles the mouse for this class
      Wobject *process_mouse(int *x = NULL, int *y = NULL);

      virtual void set(BITMAP *bmp, int mode); // if bimap= 0 mode= color
  protected:
      void draw(BITMAP *onto,int from_x, int from_y, int to_x, int to_y);
  private:

		BITMAP *the_bmp;
      int mode;

};

#endif // end of headerfile
