/****************************************************************************
 * WHAM windowing system for Allegro & DJGPP                                *
 * Copyright 1997 Martijn Versteegh                                         *
 * WHAM is swapware                                                         *
 * that means if you use it you must send me something in return            *
 * If you use WHAM in a commercial product, 'something' should preferrable  *
 * be money. A program you made, a postcard or something like that will do  *
 * in most other cases.                                                     *
 *  for contact info see contact.txt in the docs directory.                 *
 *                                                                          *
 *  Disclaimer:                                                             *
 *      I am not responsible for any effect this software may have on you,  *
 *      your properties or anything else connected to you.                  *
 *      Use it at your own risk.                                            *
 ****************************************************************************/

#ifndef _bordered_h_
#define _bordered_h_
#include <window.h>
#include <sysbox.h>

#define BORDERWIN_OPAQUE 1
#define BORDERWIN_CLEAR  2



class BorderWin: public Window
{
    public:
        //constructo/destructor
        BorderWin(int size_x,int size_y,int pos_x,int pos_y, char *title);
        BorderWin(BITMAP *bmp,int pos_x,int pos_y,char *title);
        BorderWin(int size_x,int size_y,int pos_x,int pos_y, char *title,WinSystem *its_manager);
        BorderWin(BITMAP *bmp,int pos_x,int pos_y,char *title,WinSystem *its_manager);
        ~BorderWin();
        //sysboxes
        static void add_system_box(BITMAP *bmp,void (*_function)(Wobject *win));
        static void destroy_system_boxes();
        // get palette of borders
        static RGB  *get_its_palette();
        // statics that need to be set ONCE at the start of the program
        static char *DatafileName;
        static int RemapPalette;
        static BITMAP *UpperBorderBitmap;
        static BITMAP *LowerBorderBitmap;
        static BITMAP *RightBorderBitmap;
        static BITMAP *LeftBorderBitmap;
        static BITMAP *UpperLeftCorner;
        static BITMAP *UpperRightCorner;
        static BITMAP *LowerLeftCorner;
        static BITMAP *LowerRightCorner;

         // statics that can be changed anytime
        static int Move_Style;

        Wobject *process_mouse(int *out_x = NULL, int *out_y = NULL);
    private:
        void create();
        static SystemBox **systemboxes;
        static int number_of_system_boxes;
        static int count;
        static int draw_border(BITMAP *onto,Wobject *the_object,int from_x,int from_y,int to_x,int to_y);
        static DATAFILE *datafile;
        static BITMAP *upper_border;
        static BITMAP *lower_border;
        static BITMAP *left_border;
        static BITMAP *right_border;
        static int max_ver_borderlength;
        static int max_hor_borderlength;

        static int upper_border_size;
        static int lower_border_size;
        static int left_border_size;
        static int right_border_size;
        BITMAP *move_cursor;
        BITMAP *crosshair;
        static RGB *its_palette;
};

// and a mouse function for this class


#endif
