/****************************************************************************
 * WHAM windowing system for Allegro & DJGPP                                *
 * Copyright 1997 Martijn Versteegh                                         *
 * WHAM is swapware                                                         *
 * that means if you use it you must send me something in return            *
 * If you use WHAM in a commercial product, 'something' should preferrable  *
 * be money. A program you made, a postcard or something like that will do  *
 * in most other cases.                                                     *
 *  for contact info see contact.txt in the docs directory.                 *
 *                                                                          *
 *  Disclaimer:                                                             *
 *      I am not responsible for any effect this software may have on you,  *
 *      your properties or anything else connected to you.                  *
 *      Use it at your own risk.                                            *
 ****************************************************************************/
#ifndef _BOXLIST_H_
#define _BOXLIST_H_
#include "wobject.h"
#include "topinc.h"

class Boxlist;
class Wobject;

Boxlist *new_boxlist_node(Wobject *owner,int xfrom,int yfrom, int xto, int yto, Boxlist *_last = NULL);
void delete_boxlist_node(Boxlist *node);
void cleanup_boxlist_cache();

class Boxlist
{
    public:
        friend class Wobject;
        friend Boxlist *new_boxlist_node(Wobject *owner,int xfrom,int yfrom, int xto, int yto, Boxlist *_last);
        friend void delete_boxlist_node(Boxlist *b);
        friend void cleanup_boxlist_cache();
        
        Boxlist(Wobject *owner,int xfrom,int yfrom,int xto,int yto,Boxlist *last = NULL);
        ~Boxlist();
        // overlays this rect over the complete list of boxes
        // by recursively calling itself until the next-pointer is NULL
        void overlay(int xfrom,int yfrom,int xto, int yto);

        // draws the boxes using owner's drawing functions
        void draw_the_boxes(BITMAP *onto,int from_x,int from_y,int to_x,int to_y);

        // draws the boxes using solid rectangles
        void draw_the_boxes(BITMAP *onto,int from_x,int from_y,int to_x,int to_y, int colors);
        void defrag_the_boxes();
        void show_the_boxes();
    private:
        int xf,yf,xt,yt;
        Boxlist *next, *last;
        Wobject *owner;

        static int tagteller;
        static int colorcount;
        int tag;
};



#endif
