/****************************************************************************
 * WHAM windowing system for Allegro & DJGPP                                *
 * Copyright 1997 Martijn Versteegh                                         *
 * WHAM is swapware                                                         *
 * that means if you use it you must send me something in return            *
 * If you use WHAM in a commercial product, 'something' should preferrable  *
 * be money. A program you made, a postcard or something like that will do  *
 * in most other cases.                                                     *
 *  for contact info see contact.txt in the docs directory.                 *
 *                                                                          *
 *  Disclaimer:                                                             *
 *      I am not responsible for any effect this software may have on you,  *
 *      your properties or anything else connected to you.                  *
 *      Use it at your own risk.                                            *
 ****************************************************************************/
#ifndef _CWHAM_H_
#define _CWHAM_H_
#include <allegro.h>

#ifdef __cplusplus
	extern "C" {
#endif



#define W_TYPE_WINDOW       0
#define W_TYPE_CLOCK        1
#define W_TYPE_GUICONTAINER 3

typedef struct WHAMOBJ
{
	void *internal_data;
   BITMAP *bmp;
} WHAMOBJ;


typedef WHAMOBJ *(*w_iiicv)(int, int,int, char *,void *);
typedef int (*i_v)(void);
typedef void (*v_v)(void);
typedef int (*v_wii)(WHAMOBJ *,int,int);
typedef int (*v_w)(WHAMOBJ *);
typedef int (*v_wiiii)(WHAMOBJ *,int,int,int ,int);
typedef void (*v_iiii)(int,int,int,int);

extern int install_wham();
extern void remove_wham();


extern w_iiicv create_wobj;
extern v_w destroy_wobj;
extern v_wii move_wobj;
extern v_w show_wobj;
extern v_w hide_wobj;

extern v_w update_window;
extern v_wiiii update_window_rect;
extern v_wiiii reset_window_viewport;

extern v_v cwham_process_events;
extern v_iiii cwham_set_colors;
extern v_wiiii set_locks_wobj;

#ifdef __cplusplus
	}
#endif


#endif
