/****************************************************************************
 * WHAM windowing system for Allegro & DJGPP                                *
 * Copyright 1997 Martijn Versteegh                                         *
 * WHAM is swapware                                                         *
 * that means if you use it you must send me something in return            *
 * If you use WHAM in a commercial product, 'something' should preferrable  *
 * be money. A program you made, a postcard or something like that will do  *
 * in most other cases.                                                     *
 *  for contact info see contact.txt in the docs directory.                 *
 *                                                                          *
 *  Disclaimer:                                                             *
 *      I am not responsible for any effect this software may have on you,  *
 *      your properties or anything else connected to you.                  *
 *      Use it at your own risk.                                            *
 ****************************************************************************/

#ifndef _GEOINFO_H_
#define _GEOINFO_H_
#include "topinc.h"
class GeoInfo
{
    public:
        GeoInfo();
        ~GeoInfo();
        void destroy();
        GeoInfo(GeoInfo const &other);
        void create(GeoInfo const &other);
        GeoInfo const &operator=(GeoInfo const &other);

        int 
            size_x,         // size of the buffer bitmap
            size_y,
            viewport_size_x,  // size of the viewport
            viewport_size_y,
            viewport_pos_x,   // position of the viewport on the buffer
            viewport_pos_y,
            screen_size_x,  // size of the window on screen
            screen_size_y,
            user_size_x,    // size of the user area on the biffer
            user_size_y,
            pos_x,          // position of the window on screen
            pos_y,
            user_pos_x,     // position of the user area on the buffer
            user_pos_y,
            tag,            // a unique int for each window
            is_locked,      // locking status
            pos_is_locked,
            scale_is_locked,
            viewport_pos_is_locked,
            viewport_size_is_locked,
            size_is_locked,
            shift_is_locked,  // lock for the shift_all function
            visibility_is_locked, // if this is locked the window cannot be hidden
            Upper_Border_Size, // border sizes
            Lower_Border_Size,
            Right_Border_Size,
            Left_Border_Size,
            has_focus,
            is_displayed;      // display info
        char 
            *name;              // name of this window
        float 
            scale_x,
            scale_y;

};
#endif
