/****************************************************************************
 * WHAM windowing system for Allegro & DJGPP                                *
 * Copyright 1997 Martijn Versteegh                                         *
 * WHAM is swapware                                                         *
 * that means if you use it you must send me something in return            *
 * If you use WHAM in a commercial product, 'something' should preferrable  *
 * be money. A program you made, a postcard or something like that will do  *
 * in most other cases.                                                     *
 *  for contact info see contact.txt in the docs directory.                 *
 *                                                                          *
 *  Disclaimer:                                                             *
 *      I am not responsible for any effect this software may have on you,  *
 *      your properties or anything else connected to you.                  *
 *      Use it at your own risk.                                            *
 ****************************************************************************/

#ifndef _helpers_h_
#define _helpers_h_
#include <stdio.h>
#include "wobject.h"
#include "topinc.h"
#include "w_mousec.h"



/* some helper functions*/
	 int mouse_is_visible();
	 void mouse_off(int xfrom = 0, int yfrom =0, int xto = -1, int yto=-1);
	 void mouse_on();
	 void freeze_mouse();
	 void thaw_mouse();
	 void out_of_mem(char *reason);
	 void out_of_mem();
	 void fatal(char *format,...);
	 void wham_trans_calc_progress(int pos);
	 void cleanup_wobjects();
	 void trace(char *format,...);
	 void ttrace(char *format,...);
	 void msgbox(char *format,...);
	 void remap_bitmap(BITMAP *bmp,PALETTE old, int method = 0);
	 void w_textout(BITMAP *b,FONT *f, char *c,int x,int y, int color,int mode);
	 void w_textout_centre(BITMAP *b,FONT *f, char *c,int x,int y, int color,int mode);
	 char *message_string(int message);
	 void show_progress(char *msg,int now,int min,int max);
	int helper_update_winlist(void *manager);
	void helper_get_winlist(WinSystem *manager);
	void helper_close_winlist();
void arced_rect(BITMAP *onto, int xf, int yf, int xt, int yt, int c);

	 extern FILE* DEBUG_OUTPUT_FILE;
	 Mouse_Cursor *set_Mouse_Cursor(Mouse_Cursor *cursor);
	 #ifndef MAX
		  #define MAX(x,y) ((x)>(y)?(x):(y))
	 #endif
	 #ifndef MIN
		  #define MIN(x,y) ((x)<(y)?(x):(y))
	 #endif

typedef struct MOUSE_STATE
{
	int is_visible;
	int is_frozen;
} MOUSE_STATE;


extern BITMAP *hw_screen;

#endif
