/****************************************************************************
 * WHAM windowing system for Allegro & DJGPP                                *
 * Copyright 1997 Martijn Versteegh                                         *
 * WHAM is swapware                                                         *
 * that means if you use it you must send me something in return            *
 * If you use WHAM in a commercial product, 'something' should preferrable  *
 * be money. A program you made, a postcard or something like that will do  *
 * in most other cases.                                                     *
 *  for contact info see contact.txt in the docs directory.                 *
 *                                                                          *
 *  Disclaimer:                                                             *
 *      I am not responsible for any effect this software may have on you,  *
 *      your properties or anything else connected to you.                  *
 *      Use it at your own risk.                                            *
 ****************************************************************************/

#ifndef _whamwin_h_
#define _whamwin_h_
#include "window.h"

class WhamWin: public Window
{
    public:

        WhamWin(int size_x,int size_y,int pos_x,int pos_y, char *title);
        WhamWin(BITMAP *bmp,int pos_x,int pos_y,char *title);
        WhamWin(int size_x,int size_y,int pos_x,int pos_y, char *title,WinSystem *its_manager);
        WhamWin(BITMAP *bmp,int pos_x,int pos_y,char *title,WinSystem *its_manager);
        ~WhamWin();
        // a mouse function for this object
        Wobject *process_mouse(int *out_x = NULL, int *out_y  = NULL);
    private:
        char *name;
        void draw_border();
        void draw_bar();
};


#endif
