#include "s_border.h"
#include "s_task.h"
#include "panel.h"
#include <helpers.h>
#include "s_wham.h"


#define IN_RANGE(x,min,max)	((x <=max) && (x >= min))


int S_Borderclass::Outline_Color1 = 16;
int S_Borderclass::Outline_Color2 = 4;
int S_Borderclass::Border_Color = 2;
int S_Borderclass::Title_Color = 0;
int S_Borderclass::Move_Style = S_BORDERCLASS_CLEAR;

static int init=0;

typedef struct OBJECT_INFO
{
	int has_buttons;
	int (*exit_func) (Wobject *obj, void *param);
   void *param;
} OBJECT_INFO;


S_Borderclass::S_Borderclass(Wobject *_the_obj)
{
	the_obj = _the_obj;

//   trace("this %p crea %p",this,the_obj);
	OBJECT_INFO *info =  new OBJECT_INFO;
   the_obj->user_data = info;
   

   info->has_buttons= FALSE; // ussume no buttons until proven otherwise (i.e. draw_border gets called)
   info->exit_func = NULL;
   info->param = NULL;
   
	hor = new ScrollBar(the_obj,TYPE_HORIZONTAL_SCROLLBAR);
	ver = new ScrollBar(the_obj,TYPE_VERTICAL_SCROLLBAR);
   roll_state = FALSE;
   the_obj->magic_number = S_WHAM_MAGIC;
   the_obj->register_as_property(hor);
   the_obj->register_as_property(ver);
   minimum_x_size = text_length(_s_wham_font,the_obj->get_geoinfo()->name)+45;

   
   WHAM->send_delayed_message(the_obj,W_MSG_CREATED,_s_wham_task_bar);
}


S_Borderclass::~S_Borderclass()
{
	if (the_obj->user_data)
   	delete (OBJECT_INFO *)(the_obj->user_data);

}


int S_Borderclass::draw_border(BITMAP *onto,Wobject *the_object,int from_x,int from_y,int to_x,int to_y)
{
    int
        f_x,f_y,t_x,t_y;
    GeoInfo const *g = the_object->get_geoinfo();
    int space_for_exit_button = 0;
    if (!onto) // return border dimensions to manager
    {
        switch(from_x)
        {
            case WINDOW_UPPER_BORDER:
                return text_height(_s_wham_font)+7;
            break;
            case WINDOW_LOWER_BORDER:
                return 4;
            break;
            case WINDOW_LEFT_BORDER:
                return 4;
            break;
            case WINDOW_RIGHT_BORDER:
                return 4;
            break;
        }

    }
    from_x=from_y=to_x= to_y = 0; // ignore values, rely on manager setting clipping rect
    //if (_mouse_screen == screen) trace(" in draw border");
    solid_mode();

    if (the_object->user_data)
	    ((OBJECT_INFO *)(the_object->user_data))->has_buttons =TRUE;

//    trace("draw border for %s",g->name);

//    int s_pos = g->screen_size_x;
    f_x = g->pos_x - 4;
    t_x = g->pos_x + g->screen_size_x + 3;
    f_y = g->pos_y - g->Upper_Border_Size;
    t_y = g->pos_y - 1;
    rectfill(onto,f_x,f_y,t_x,t_y,Border_Color);
    hline (onto,f_x,f_y,t_x,Outline_Color1);
  	 hline (onto,g->pos_x - 1,g->pos_y - 1,g->pos_x+g->screen_size_x ,Outline_Color2);

    if (g->name)
    {
        text_mode(Border_Color);
        textout(onto,_s_wham_font,g->name,g->pos_x , g->pos_y - g->Upper_Border_Size + 4,Title_Color);
    }
    //      circlefill(onto, g->pos_x + g->screen_size_x -7, g->pos_y - 7,4, Title_Color);

    space_for_exit_button = ((OBJECT_INFO *)(the_object->user_data))->exit_func ? 14 : 0;

    rectfill(onto, g->pos_x + g->screen_size_x - 43 - space_for_exit_button, g->pos_y - 2, g->pos_x + g->screen_size_x + 2, g->pos_y -14, Border_Color);
    
    if (the_object->user_data && ((OBJECT_INFO *)(the_object->user_data))->exit_func)
    {
       vline(onto, g->pos_x + g->screen_size_x - 14 , g->pos_y - 13,g->pos_y - 3, Outline_Color1);
       vline(onto, g->pos_x + g->screen_size_x - 2 , g->pos_y - 12,g->pos_y - 3, Outline_Color2);
       hline(onto, g->pos_x + g->screen_size_x - 14 , g->pos_y - 13,g->pos_x + g->screen_size_x - 2, Outline_Color1);
       hline(onto, g->pos_x + g->screen_size_x - 13 , g->pos_y - 3,g->pos_x + g->screen_size_x - 2, Outline_Color2);

       line(onto, g->pos_x + g->screen_size_x - 12 , g->pos_y - 5,g->pos_x + g->screen_size_x - 6, g->pos_y - 10, Outline_Color2);
       line(onto, g->pos_x + g->screen_size_x - 12 , g->pos_y - 10, g->pos_x + g->screen_size_x - 6,g->pos_y - 5, Outline_Color2);
//       line(onto, g->pos_x + g->screen_size_x - 12 , g->pos_y - 6,g->pos_x + g->screen_size_x - 6, g->pos_y - 11, Outline_Color2);
//       line(onto, g->pos_x + g->screen_size_x - 12 , g->pos_y - 11, g->pos_x + g->screen_size_x - 6,g->pos_y - 6, Outline_Color2);
//       line(onto, g->pos_x + g->screen_size_x - 11 , g->pos_y - 6,g->pos_x + g->screen_size_x - 5, g->pos_y - 11, Outline_Color2);
//       line(onto, g->pos_x + g->screen_size_x - 11 , g->pos_y - 11, g->pos_x + g->screen_size_x - 5,g->pos_y - 6, Outline_Color2);

       line(onto, g->pos_x + g->screen_size_x - 11 , g->pos_y - 4,g->pos_x + g->screen_size_x - 5, g->pos_y - 9, Outline_Color1);
       line(onto, g->pos_x + g->screen_size_x - 11 , g->pos_y - 9, g->pos_x + g->screen_size_x - 5,g->pos_y - 4, Outline_Color1);
//       line(onto, g->pos_x + g->screen_size_x - 10 , g->pos_y - 4,g->pos_x + g->screen_size_x - 4, g->pos_y - 9, Outline_Color1);
//       line(onto, g->pos_x + g->screen_size_x - 10 , g->pos_y - 9, g->pos_x + g->screen_size_x - 4,g->pos_y - 4, Outline_Color1);
//       line(onto, g->pos_x + g->screen_size_x - 10 , g->pos_y - 5,g->pos_x + g->screen_size_x - 4, g->pos_y - 10, Outline_Color1);
//       line(onto, g->pos_x + g->screen_size_x - 10 , g->pos_y - 10, g->pos_x + g->screen_size_x - 4,g->pos_y - 5, Outline_Color1);

       line(onto, g->pos_x + g->screen_size_x - 11 , g->pos_y - 5,g->pos_x + g->screen_size_x - 5, g->pos_y - 10,Title_Color);
       line(onto, g->pos_x + g->screen_size_x - 11 , g->pos_y - 10, g->pos_x + g->screen_size_x - 5,g->pos_y - 5,Title_Color);
//       rect(onto, g->pos_x + g->screen_size_x -12 , g->pos_y - 11,g->pos_x + g->screen_size_x - 4, g->pos_y - 5, Title_Color);
    }
    vline(onto, g->pos_x + g->screen_size_x - 14 - space_for_exit_button, g->pos_y - 13,g->pos_y - 3, Outline_Color1);
    vline(onto, g->pos_x + g->screen_size_x - 2 - space_for_exit_button, g->pos_y - 12,g->pos_y - 3, Outline_Color2);
    hline(onto, g->pos_x + g->screen_size_x - 14 - space_for_exit_button, g->pos_y - 13,g->pos_x + g->screen_size_x - 2 - space_for_exit_button, Outline_Color1);
    hline(onto, g->pos_x + g->screen_size_x - 13 - space_for_exit_button, g->pos_y - 3,g->pos_x + g->screen_size_x - 2 - space_for_exit_button, Outline_Color2);
    rect(onto, g->pos_x + g->screen_size_x -12 - space_for_exit_button, g->pos_y - 11,g->pos_x + g->screen_size_x -4 - space_for_exit_button, g->pos_y - 5, Title_Color);
    

    vline(onto, g->pos_x + g->screen_size_x - 28 - space_for_exit_button, g->pos_y - 13,g->pos_y - 3, Outline_Color1);
    vline(onto, g->pos_x + g->screen_size_x - 16 - space_for_exit_button, g->pos_y - 12,g->pos_y - 3, Outline_Color2);
    hline(onto, g->pos_x + g->screen_size_x - 28 - space_for_exit_button, g->pos_y - 13,g->pos_x + g->screen_size_x - 16 - space_for_exit_button, Outline_Color1);
    hline(onto, g->pos_x + g->screen_size_x - 27 - space_for_exit_button, g->pos_y - 3,g->pos_x + g->screen_size_x - 16 - space_for_exit_button, Outline_Color2);
    rectfill(onto, g->pos_x + g->screen_size_x -26 - space_for_exit_button, g->pos_y - 6,g->pos_x + g->screen_size_x -18 - space_for_exit_button, g->pos_y - 5, Title_Color);

    vline(onto, g->pos_x + g->screen_size_x - 42 - space_for_exit_button, g->pos_y - 13,g->pos_y - 3, Outline_Color1);
    vline(onto, g->pos_x + g->screen_size_x - 30 - space_for_exit_button, g->pos_y - 12,g->pos_y - 3, Outline_Color2);
    hline(onto, g->pos_x + g->screen_size_x - 42 - space_for_exit_button, g->pos_y - 13,g->pos_x + g->screen_size_x - 30 - space_for_exit_button, Outline_Color1);
    hline(onto, g->pos_x + g->screen_size_x - 41 - space_for_exit_button, g->pos_y - 3,g->pos_x + g->screen_size_x - 30 - space_for_exit_button, Outline_Color2);
    circlefill(onto, g->pos_x + g->screen_size_x -36 - space_for_exit_button, g->pos_y - 8,4, Title_Color);

    //lower border                         
    f_x = g->pos_x - 4;
    t_x = g->pos_x + g->screen_size_x + 3;
    f_y = g->pos_y + g->screen_size_y;     
    t_y = g->pos_y + g->screen_size_y + 3;
                                           
    rectfill(onto,f_x,f_y,t_x,t_y,Border_Color);
    hline(onto,f_x,t_y,t_x,Outline_Color2);
	 hline(onto,g->pos_x,f_y,g->pos_x + g->screen_size_x,Outline_Color1);

    //left border                          
    f_x = g->pos_x - 4;
    t_x = g->pos_x - 1;
    f_y = g->pos_y ;
    t_y = g->pos_y + g->screen_size_y - 1;     
                                           
    rectfill(onto,f_x,f_y,t_x,t_y,Border_Color);
    vline(onto,f_x,f_y - g->Upper_Border_Size + 1,t_y + 3,Outline_Color1);
	 vline(onto,g->pos_x - 1,g->pos_y ,g->pos_y + g->screen_size_y ,Outline_Color2);
                                           
    //right border                         
    f_x = g->pos_x + g->screen_size_x;     
    t_x = g->pos_x + g->screen_size_x + 3;
    f_y = g->pos_y ;
    t_y = g->pos_y + g->screen_size_y - 1;     
                                           
    rectfill(onto,f_x,f_y,t_x,t_y,Border_Color);
    vline(onto,t_x,f_y - g->Upper_Border_Size + 1,t_y + 3,Outline_Color2);
	 vline(onto,g->pos_x + g->screen_size_x,g->pos_y ,g->pos_y + g->screen_size_y ,Outline_Color1);
                                           
                                           

    return 0;
}


int S_Borderclass::draw_frame(BITMAP *onto,Wobject *the_object,int from_x,int from_y,int to_x,int to_y)
{
    int
        f_x,f_y,t_x,t_y;
    GeoInfo const *g = the_object->get_geoinfo();


    if (!onto) // return border dimensions to manager
    {
        switch(from_x)
        {
            case WINDOW_UPPER_BORDER:
                return 4;
            break;
            case WINDOW_LOWER_BORDER:
                return 4;
            break;
            case WINDOW_LEFT_BORDER:
                return 4;
            break;
            case WINDOW_RIGHT_BORDER:
                return 4;
            break;
        }

    }
    from_x=from_y=to_x= to_y = 0; // ignore values, rely on manager setting clipping rect

    //if (_mouse_screen == screen) trace(" in draw border");
    solid_mode();

    // upper border
    f_x = g->pos_x - 4;
    t_x = g->pos_x + g->screen_size_x + 3;
    f_y = g->pos_y - 4;
    t_y = g->pos_y - 1;
    rectfill(onto,f_x,f_y,t_x,t_y,Border_Color);
    hline (onto,f_x,f_y,t_x,Outline_Color1);
  	 hline (onto,g->pos_x - 1,g->pos_y - 1,g->pos_x+g->screen_size_x ,Outline_Color2);


    //lower border                         
    f_x = g->pos_x - 4;
    t_x = g->pos_x + g->screen_size_x + 3;
    f_y = g->pos_y + g->screen_size_y;     
    t_y = g->pos_y + g->screen_size_y + 3;
                                           
    rectfill(onto,f_x,f_y,t_x,t_y,Border_Color);
    hline(onto,f_x,t_y,t_x,Outline_Color2);
	 hline(onto,g->pos_x,f_y,g->pos_x + g->screen_size_x,Outline_Color1);

    //left border                          
    f_x = g->pos_x - 4;
    t_x = g->pos_x - 1;
    f_y = g->pos_y ;
    t_y = g->pos_y + g->screen_size_y - 1;     
                                           
    rectfill(onto,f_x,f_y,t_x,t_y,Border_Color);
    vline(onto,f_x,f_y - 4,t_y + 3,Outline_Color1);
	 vline(onto,g->pos_x - 1,g->pos_y ,g->pos_y + g->screen_size_y ,Outline_Color2);
                                           
    //right border                         
    f_x = g->pos_x + g->screen_size_x;     
    t_x = g->pos_x + g->screen_size_x + 3;
    f_y = g->pos_y ;
    t_y = g->pos_y + g->screen_size_y - 1;     
                                           
    rectfill(onto,f_x,f_y,t_x,t_y,Border_Color);
    vline(onto,t_x,f_y - 4,t_y + 3,Outline_Color2);
	 vline(onto,g->pos_x + g->screen_size_x,g->pos_y ,g->pos_y + g->screen_size_y ,Outline_Color1);
                                           
                                           

    return 0;
}

int S_Borderclass::draw_box(BITMAP *onto,Wobject *the_object,int from_x,int from_y,int to_x,int to_y)
{
    int
        f_x,f_y,t_x,t_y;
    GeoInfo const *g = the_object->get_geoinfo();


    if (!onto) // return border dimensions to manager
    {
        switch(from_x)
        {
            case WINDOW_UPPER_BORDER:
                return 4;
            break;
            case WINDOW_LOWER_BORDER:
                return 4;
            break;
            case WINDOW_LEFT_BORDER:
                return 4;
            break;
            case WINDOW_RIGHT_BORDER:
                return 4;
            break;
        }

    }
    from_x=from_y=to_x= to_y = 0; // ignore values, rely on manager setting clipping rect

    //if (_mouse_screen == screen) trace(" in draw border");
    solid_mode();

    // upper border
    f_x = g->pos_x - 4;
    t_x = g->pos_x + g->screen_size_x + 3;
    f_y = g->pos_y - 4;
    t_y = g->pos_y - 1;
    rectfill(onto,f_x,f_y,t_x,t_y,Border_Color);
    hline (onto,f_x,f_y,t_x,Outline_Color1);
  	 hline (onto,g->pos_x - 1,g->pos_y - 1,g->pos_x+g->screen_size_x ,Border_Color);


    //lower border                         
    f_x = g->pos_x - 4;
    t_x = g->pos_x + g->screen_size_x + 3;
    f_y = g->pos_y + g->screen_size_y;     
    t_y = g->pos_y + g->screen_size_y + 3;
                                           
    rectfill(onto,f_x,f_y,t_x,t_y,Border_Color);
    hline(onto,f_x,t_y,t_x,Outline_Color2);
	 hline(onto,g->pos_x,f_y,g->pos_x + g->screen_size_x,Border_Color);

    //left border                          
    f_x = g->pos_x - 4;
    t_x = g->pos_x - 1;
    f_y = g->pos_y ;
    t_y = g->pos_y + g->screen_size_y - 1;     
                                           
    rectfill(onto,f_x,f_y,t_x,t_y,Border_Color);
    vline(onto,f_x,f_y - 4,t_y + 3,Outline_Color1);
	 vline(onto,g->pos_x - 1,g->pos_y ,g->pos_y + g->screen_size_y ,Border_Color);
                                           
    //right border                         
    f_x = g->pos_x + g->screen_size_x;     
    t_x = g->pos_x + g->screen_size_x + 3;
    f_y = g->pos_y ;
    t_y = g->pos_y + g->screen_size_y - 1;     
                                           
    rectfill(onto,f_x,f_y,t_x,t_y,Border_Color);
    vline(onto,t_x,f_y - 4,t_y + 3,Outline_Color2);
	 vline(onto,g->pos_x + g->screen_size_x,g->pos_y ,g->pos_y + g->screen_size_y ,Border_Color);
                                           
                                           

    return 0;
}



//process mouse part
Wobject *S_Borderclass::process_mouse(int *x_out, int *y_out)
{
    x_out = y_out = NULL; // silence compiler
    Wobject *win;
    int out_x,out_y,mouse_was_x,mouse_was_y,pos_was_x,pos_was_y,mouse_is_x,mouse_is_y,size_was_x,size_was_y;
    int tmp_x,tmp_y;
    int flag;
    GeoInfo const *g;
    int mouse_visible = mouse_is_visible();
    int max_mouse_x, min_mouse_x;
    int max_mouse_y, min_mouse_y;
	 Panel *coord_disp;
    int coord_disp_size_x;
    int coord_disp_size_y;
    int space_for_exit_button;
    win =WHAM->process_coordinates(mouse_x,mouse_y,&out_x,&out_y,&flag);
    if (!win)
    {
      set_Mouse_Cursor(WinSystem::Mouse_Cursor0);
    	return NULL;
    }
    if (x_out)
    	*x_out = out_x;

    if (y_out)
    	*y_out = out_y;
      

    if (!flag)
    {
      set_Mouse_Cursor(WinSystem::Mouse_Cursor0);
      return (Wobject *)win;
    }

    g = win->get_geometric_info();
    space_for_exit_button = ((OBJECT_INFO *)(win->user_data))->exit_func ? 14 : 0;
    if (out_x <0 || (out_y <0 && (mouse_b & 1)))
    {
    	if (out_x < g->screen_size_x - 42 - space_for_exit_button)
        set_Mouse_Cursor(WinSystem::Mouse_Cursor1);
      else
        set_Mouse_Cursor(WinSystem::Mouse_Cursor0);
    }
    else if (out_y > 0)
    {
    	if (g->viewport_size_is_locked)
        set_Mouse_Cursor(WinSystem::Mouse_Cursor1);
      else
        set_Mouse_Cursor(WinSystem::Mouse_Cursor2);
    }
    else
        set_Mouse_Cursor(WinSystem::Mouse_Cursor0);
    
    mouse_was_x = mouse_x;
    mouse_was_y = mouse_y;
    pos_was_x = g->pos_x;
    pos_was_y = g->pos_y;
    size_was_x = g->screen_size_x;
    size_was_y = g->screen_size_y;

    
    tmp_x = mouse_was_x;
    tmp_y = mouse_was_y;
    if (mouse_b & 1)
    {
				xor_mode(TRUE);
            if (out_y <0 && ((OBJECT_INFO *)(win->user_data))->has_buttons && out_x > g->screen_size_x - 42 - space_for_exit_button )
            {
               if (((OBJECT_INFO *)(win->user_data))->exit_func && out_x > g->screen_size_x - space_for_exit_button && out_x < g->screen_size_x - 2 )
               {
               	while(mouse_b);
			   		if (((OBJECT_INFO *)(win->user_data))->exit_func(win,((OBJECT_INFO *)(win->user_data))->param))
                  	win->request(W_REQUEST_DELETE);
                  
               }
    		   	else if (out_x > g->screen_size_x - 14 - space_for_exit_button && out_x < g->screen_size_x - 2 - space_for_exit_button)
               {
               	while(mouse_b);
               	maximise();
               }
               else if (out_x > g->screen_size_x - 28  - space_for_exit_button)
               {
               	while(mouse_b);
               	minimise();
               }
               else if (out_x > g->screen_size_x - 42  - space_for_exit_button)
               {
               	while(mouse_b);
               	roll();
               }
            }
            else if (out_x < 0 || out_y <0)
            {

            	 coord_disp_size_x = text_length(font,"9999 x 9999") + 10;
            	 coord_disp_size_y = text_height(font) + 2;
                coord_disp = new Panel(coord_disp_size_x,coord_disp_size_y,(SCREEN_W - coord_disp_size_x)/ 2,(SCREEN_H - coord_disp_size_y)/2,"coordinates display");
					 coord_disp->raise_and_lock();
                coord_disp->show();
                if (((S_Borderclass *)win)->Move_Style == S_BORDERCLASS_CLEAR)
                {
                    mouse_off(pos_was_x - 4,pos_was_y - 15, pos_was_x + size_was_x  +3, pos_was_y + size_was_y  +3);
						  vsync();
                    rect(screen,pos_was_x - 4, pos_was_y - 15, pos_was_x + size_was_x  +3, pos_was_y + size_was_y  +3,s_wham_xor_color);
                    mouse_on();
                }
                while (mouse_b & 1)
                {
                	  while (mouse_is_x == mouse_x && mouse_is_y == mouse_y && mouse_b); // wait till anything changes
                    mouse_is_x = mouse_x;
                    mouse_is_y = mouse_y;
                    if (win->get_manager()->get_parent())
                        win->get_manager()->get_parent()->transform_coordinates(&mouse_is_x,&mouse_is_y);

                    if (((S_Borderclass *)win)->Move_Style == S_BORDERCLASS_CLEAR && ((tmp_x != mouse_x)||(tmp_y != mouse_y)))
                    {
                    
                        mouse_off
                        (
                            pos_was_x + tmp_x - mouse_was_x - 4,
                            pos_was_y + tmp_y - mouse_was_y - 15,
                            pos_was_x + size_was_x  - 1 + tmp_x - mouse_was_x + 4,
                            pos_was_y + size_was_y  - 1 + tmp_y - mouse_was_y + 4
                        );
                        vsync();
                        rect
                        (
                            screen,
                            pos_was_x + tmp_x - mouse_was_x - 4,
                            pos_was_y + tmp_y - mouse_was_y - 15,
                            pos_was_x + size_was_x  - 1 + tmp_x - mouse_was_x + 4,
                            pos_was_y + size_was_y  - 1 + tmp_y - mouse_was_y + 4,
                            s_wham_xor_color
                        );
                        tmp_x = mouse_is_x;
                        tmp_y = mouse_is_y;
                        rect
                        (
                            screen,
                            pos_was_x + tmp_x - mouse_was_x - 4,
                            pos_was_y + tmp_y - mouse_was_y - 15,
                            pos_was_x + size_was_x  - 1 + tmp_x - mouse_was_x + 4,
                            pos_was_y + size_was_y  - 1 + tmp_y - mouse_was_y + 4,
                            s_wham_xor_color
                        );
                        mouse_on();
                            

                    }
                    else if (((S_Borderclass *)win)->Move_Style == S_BORDERCLASS_OPAQUE)
                    {
                    		vsync();
                        win->move(pos_was_x + mouse_is_x - mouse_was_x, pos_was_y + mouse_is_y - mouse_was_y);
                    }

                    textprintf_centre(coord_disp->bmp(), font, coord_disp->bmp()->w / 2, 2, Title_Color,"   %d , %d   ",pos_was_x + mouse_is_x - mouse_was_x, pos_was_y + mouse_is_y - mouse_was_y);
                    coord_disp->update();
                }

                if (((S_Borderclass *)win)->Move_Style == S_BORDERCLASS_CLEAR)
                {
                    mouse_off
                    (
                        pos_was_x + tmp_x - mouse_was_x - 4,
                        pos_was_y + tmp_y - mouse_was_y - 15,
                        pos_was_x + size_was_x  - 1 + tmp_x - mouse_was_x + 4,
                        pos_was_y + size_was_y  - 1 + tmp_y - mouse_was_y + 4
                    );
                    vsync();
                    rect
                    (
                        screen,
                        pos_was_x + tmp_x - mouse_was_x - 4,
                        pos_was_y + tmp_y - mouse_was_y - 15,
                        pos_was_x + size_was_x  - 1 + tmp_x - mouse_was_x + 4,
                        pos_was_y + size_was_y  - 1 + tmp_y - mouse_was_y + 4,
                        s_wham_xor_color
                    );
          			  mouse_on();
                    win->move(pos_was_x + mouse_is_x - mouse_was_x,pos_was_y + mouse_is_y - mouse_was_y);
                }
					 delete coord_disp;
            }
            else if (!roll_state)
            {
            
            	 coord_disp_size_x = text_length(font,"9999 x 9999") + 10;
            	 coord_disp_size_y = text_height(font) + 2;
                coord_disp = new Panel(coord_disp_size_x,coord_disp_size_y,(SCREEN_W - coord_disp_size_x)/ 2,(SCREEN_H - coord_disp_size_y)/2,"coordinates display");
					 coord_disp->raise_and_lock();
                coord_disp->show();

                if (((S_Borderclass *)win)->Move_Style == S_BORDERCLASS_CLEAR)
                {
                    mouse_off(pos_was_x, pos_was_y , pos_was_x + size_was_x  - 1, pos_was_y + size_was_y  - 1);
                    rect(screen,pos_was_x, pos_was_y , pos_was_x + size_was_x  - 1, pos_was_y + size_was_y  - 1,s_wham_xor_color);
                    mouse_on();
                }

                max_mouse_x =  (int)(g->size_x * g->scale_x) + mouse_was_x -  size_was_x;
					 max_mouse_y =  (int)(g->size_y * g->scale_y) + mouse_was_y -  size_was_y;
					 min_mouse_x = mouse_was_x -  size_was_x + 43;
					 min_mouse_y = mouse_was_y -  size_was_y;
                while (mouse_b & 1)
                {
                    mouse_is_x = mouse_x;
                    mouse_is_y = mouse_y;
                    if (win->get_manager()->get_parent())
                        win->get_manager()->get_parent()->transform_coordinates(&mouse_is_x,&mouse_is_y);


                        
                    if (      // warning UGLY IF!!!!
                    			(
                           	((S_Borderclass *)win)->Move_Style == S_BORDERCLASS_CLEAR
                              &&
                              (
                              	(tmp_x != mouse_x && IN_RANGE(mouse_is_x, min_mouse_x,max_mouse_x))
                              	||
                                 (tmp_y != mouse_y && IN_RANGE(mouse_is_y, min_mouse_y,max_mouse_y))
                              )
                           )
                       )
                    {
                        mouse_off(); // turn it off completely for freezing it means it will be frozen 99.99% of the time, and the mouse button lift will not be detected
                        vsync();
                        rect
                        (
                            screen,
                            pos_was_x,
                            pos_was_y, 
                            pos_was_x + size_was_x  - 1 + tmp_x - mouse_was_x, 
                            pos_was_y + size_was_y  - 1 + tmp_y - mouse_was_y,
                            s_wham_xor_color
                        );
                    if (IN_RANGE(mouse_is_x, min_mouse_x,max_mouse_x))
                        tmp_x = mouse_x;

                    if (IN_RANGE(mouse_is_y, min_mouse_y,max_mouse_y))
                        tmp_y = mouse_y;
                        
                    	   vsync();
                        rect
                        (
                            screen,
                            pos_was_x, 
                            pos_was_y, 
                            pos_was_x + size_was_x  - 1 + tmp_x - mouse_was_x, 
                            pos_was_y + size_was_y  - 1 + tmp_y - mouse_was_y,
                            s_wham_xor_color
                        );
								mouse_on();
                            

                    }
                    else if (((S_Borderclass *)win)->Move_Style == S_BORDERCLASS_OPAQUE)
                    {
                    		 vsync();
                         if (key_shifts * KB_ALT_FLAG)
                             win->rescale(size_was_x + mouse_is_x - mouse_was_x,size_was_y + mouse_is_y - mouse_was_y);
                         else
                             win->resize_s_viewport(size_was_x + mouse_is_x - mouse_was_x,size_was_y + mouse_is_y - mouse_was_y);
                    }

                    textprintf_centre(coord_disp->bmp(), font, coord_disp->bmp()->w / 2, 2, Title_Color,"   %d , %d   ",win->get_geoinfo()->screen_size_x,win->get_geoinfo()->screen_size_y);
                    coord_disp->update();

                }
                
                if (((S_Borderclass *)win)->Move_Style == S_BORDERCLASS_CLEAR)
                {
                    mouse_off
                    (
                        pos_was_x , 
                        pos_was_y , 
                        pos_was_x + size_was_x  - 1 + tmp_x - mouse_was_x, 
                        pos_was_y + size_was_y  - 1 + tmp_y - mouse_was_y
                    );
                    rect
                    (
                        screen,
                        pos_was_x , 
                        pos_was_y , 
                        pos_was_x + size_was_x  - 1 + tmp_x - mouse_was_x, 
                        pos_was_y + size_was_y  - 1 + tmp_y - mouse_was_y,
                        s_wham_xor_color
                    );
                    mouse_on();
             		  vsync();
                    if (key_shifts * KB_ALT_FLAG)
                        win->rescale(size_was_x + mouse_is_x - mouse_was_x,size_was_y + mouse_is_y - mouse_was_y);
                    else
                        win->resize_s_viewport(size_was_x + mouse_is_x - mouse_was_x,size_was_y + mouse_is_y - mouse_was_y);

                }
                delete coord_disp;
            }
     			solid_mode();
   }
    return NULL;

}


void S_Borderclass::minimise()
{
   int fx,fy,fw,fh,x,y,w,h,tx,ty,tw,th;
   
   if (the_obj->get_geoinfo()->is_displayed)
   {
      xor_mode(TRUE);
      _s_wham_task_bar->get_coordinates_of_button(the_obj,&tx,&ty,&tw,&th);
   	tx += _s_wham_task_bar->get_geoinfo()->pos_x;
   	ty += _s_wham_task_bar->get_geoinfo()->pos_y;
      
      fx = the_obj->get_geoinfo()->pos_x;
      fy = the_obj->get_geoinfo()->pos_y;
      fw = the_obj->get_geoinfo()->screen_size_x;
      fh = the_obj->get_geoinfo()->screen_size_y;
      for (int i=0;i<20;i++)
      {
       	x = (tx * i+ fx * (20 -i))/20;
       	y = (ty * i+ fy * (20 -i))/20;
       	w = (tw * i+ fw * (20 -i))/20;
       	h = (th * i+ fh * (20 -i))/20;
         mouse_off();
         rect(WHAM->TheScreen,x,y,x+w-1,y+h-1,s_wham_xor_color);
         mouse_on();
         rest(5);
         mouse_off();
         rect(WHAM->TheScreen,x,y,x+w-1,y+h-1,s_wham_xor_color);
         mouse_on();
         
   
      }
      solid_mode();

   }

   
   the_obj->hide();
}

void S_Borderclass::roll()
{
   int unrolled_pos_x;
   int pos_y;
   int tmp_x_size;
   int rolled_x_size = minimum_x_size;
   
   pos_y = the_obj->get_geoinfo()->pos_y;
	roll_state = !roll_state;
   if (roll_state)
   {
   	hor->disable();
      ver->disable();
      unrolled_pos_x = the_obj->get_geoinfo()->pos_x;
      y_size_before_roll = the_obj->get_geoinfo()->screen_size_y;
		x_size_before_roll = the_obj->get_geoinfo()->screen_size_x;
      for (int i=9;i>=0;i--)
      {
      	the_obj->resize_s_viewport(x_size_before_roll, (y_size_before_roll * i) / 10);
         rest(3);
      }
      for (int i=9;i>=0;i--)
      {
         tmp_x_size = x_size_before_roll * i/10 + (10-i)*rolled_x_size/10;
      	the_obj->resize_s_viewport(tmp_x_size, 0);
         the_obj->move(unrolled_pos_x + x_size_before_roll - tmp_x_size, pos_y);
         rest(15);
      }
   }
   else
   {
      unrolled_pos_x = the_obj->get_geoinfo()->pos_x + rolled_x_size - x_size_before_roll;
      for (int i=1;i<=10;i++)
      {
      	tmp_x_size = x_size_before_roll * i/10 + (10-i)*rolled_x_size/10;
         if (x_size_before_roll > rolled_x_size)
	      	the_obj->freeze();
         the_obj->move(unrolled_pos_x + x_size_before_roll - tmp_x_size, pos_y);
      	the_obj->resize_s_viewport(tmp_x_size, 0);
         if (x_size_before_roll > rolled_x_size)
	      	the_obj->thaw();
         rest(15);
      }

      for (int i=1;i <=10;i++)
      {
      	the_obj->resize_s_viewport(x_size_before_roll, (y_size_before_roll * i) / 10);
         rest(3);
      }
    	hor->enable();
      ver->enable();
   }
}

void S_Borderclass::maximise()
{
//   trace("this %d thobj %p",this,the_obj);
	if (roll_state) // first unroll
   	roll();
   int nw_size_x = (int)(the_obj->get_geoinfo()->size_x * the_obj->get_geoinfo()->scale_x);
   int nw_size_y = (int)(the_obj->get_geoinfo()->size_y * the_obj->get_geoinfo()->scale_y);

   the_obj->resize_s_viewport(nw_size_x, nw_size_y);

}

void S_Borderclass::add_close_button(int (*exit_callback)(Wobject *w, void *param), void *param)
{
//   trace("add close b this %p to %p",this,the_obj);
	OBJECT_INFO *info = (OBJECT_INFO *)(the_obj->user_data);

//   trace("ud %p",the_obj->user_data);
	info->exit_func = exit_callback;
	info->param = param;
   
   the_obj->request(W_REQUEST_UPDATE);
}


#undef IN_RANGE
