/****************************************************************************
 * WHAM windowing system for Allegro & DJGPP                                *
 * Copyright 1997 Martijn Versteegh                                         *
 * WHAM is swapware                                                         *
 * that means if you use it you must send me something in return            *
 * If you use WHAM in a commercial product, 'something' should preferrable  *
 * be money. A program you made, a postcard or something like that will do  *
 * in most other cases.
 * I can be reached at                                                      *
 *  m.versteegh@cpedu.rug.nl                                                *
 *    or , if the above is expired                                          *
 *  vsteegh@dds.nl (my parents)                                             *
 *                                                                          *
 *  postbox 1443 9701BK Groningen, The Netherlands.                         *
 *                                                                          *
 *  Disclaimer:                                                             *
 *      I am not responsible for any effect this software may have on you,  *
 *      your properties or anything else connected to you.                  *
 *      Use it at your own risk.                                            *
 ****************************************************************************/


#include <stdio.h>
#include <strings.h>
#include "s_dialog.h"
extern BITMAP *_mouse_screen;


S_Dialog::S_Dialog(char *_name, DIALOG * d,int _size_x,int _size_y,int _pos_x, int _pos_y,  int syspriority)
    : AlGuiContainer(_size_x,_size_y,_pos_x,_pos_y ,_name, d, S_Borderclass::draw_frame, syspriority),
      S_Borderclass(this)
{
    create();
}

S_Dialog::S_Dialog(char *_name, DIALOG * d,int _size_x,int _size_y,int _pos_x, int _pos_y)
    : AlGuiContainer(_size_x,_size_y,_pos_x,_pos_y ,_name, d, S_Borderclass::draw_border, FALSE),
      S_Borderclass(this)
{
    create();
}


void S_Dialog::create()
{

}


S_Dialog::~S_Dialog()
{
}



Wobject *S_Dialog::process_mouse(int *x_out, int *y_out)
{
    Wobject *win;
    int out_x,out_y,mouse_was_x,mouse_was_y,pos_was_x,pos_was_y,mouse_is_x,mouse_is_y,size_was_x,size_was_y;
    int tmp_x,tmp_y;
    int flag;
    GeoInfo const *g;
    win =WHAM->process_coordinates(mouse_x,mouse_y,&out_x,&out_y,&flag);
    if (x_out)
        *x_out = out_x;
    if (y_out)
        *y_out = out_y;
    
    if (win != this)
    {
        set_Mouse_Cursor(WinSystem::Mouse_Cursor0);
        return win;
    }
    
    if (flag)
		return S_Borderclass::process_mouse(x_out,y_out);

    set_Mouse_Cursor(WinSystem::Mouse_Cursor0);


    g = win->get_geometric_info();
    mouse_was_x = mouse_x;
    mouse_was_y = mouse_y;
    pos_was_x = g->pos_x;
    pos_was_y = g->pos_y;
    size_was_x = g->screen_size_x;
    size_was_y = g->screen_size_y;
    tmp_x = mouse_was_x;
    tmp_y = mouse_was_y;
    if (win->get_manager()->get_parent())
        win->get_manager()->get_parent()->transform_coordinates(&mouse_was_x,&mouse_was_y);

    AlGuiContainer::process_mouse();

    if ((mouse_b & 2))
    {
        pos_was_x = g->viewport_pos_x;
        pos_was_y = g->viewport_pos_y;
        while (mouse_b & 2)
        {
            mouse_is_x = mouse_x;
            mouse_is_y = mouse_y;
            if (win->get_manager()->get_parent())
                win->get_manager()->get_parent()->transform_coordinates(&mouse_is_x,&mouse_is_y);
    
            win->move_viewport(pos_was_x - mouse_is_x + mouse_was_x,pos_was_y - mouse_is_y + mouse_was_y);
        }
    }


    if (mouse_b & 1)
            win->raise();

    return (Wobject *)win;
}

