#include <stdio.h>
#include "s_wham.h"
#include "s_border.h"
#include <separatr.h>
#include <panel.h>
#include "mousedat.h"
#include <alguicon.h> // for raise style

int s_wham_xor_color;
extern int _allegro_count;

static BITMAP *resize;
static BITMAP *move;



static int unpack_color(unsigned int packed_color)
{

   return makecol(packed_color >> 16, (packed_color >> 8) & 0xFF,packed_color & 0xFF);
}

void s_wham_restore_colors()
{
   Panel::Background_Color = S_Borderclass::Border_Color = unpack_color(get_config_hex("S_WHAMWINDOWS","BorderColor",0x646464));
   Panel::Light_Outline_Color = S_Borderclass::Outline_Color1 = unpack_color(get_config_hex("S_WHAMWINDOWS","OutlineColor1",0xFFFFFF));
   Panel::Dark_Outline_Color = S_Borderclass::Outline_Color2 = unpack_color(get_config_hex("S_WHAMWINDOWS","OutlineColor2",	0x323232));
   WinSystem::BackgroundColor = unpack_color(get_config_hex("S_WHAMWINDOWS","BackgroundColor",0x000000));
   S_Borderclass::Title_Color = unpack_color(get_config_hex("S_WHAMWINDOWS","TitleColor",0x000000));
   gui_fg_color = unpack_color(get_config_hex("S_WHAMWINDOWS","FgColor",0x000000));
   gui_bg_color = unpack_color(get_config_hex("S_WHAMWINDOWS","BgColor",0xFFFFFF));
   ScrollBar::White_Color = makecol(255,255,255);
   ScrollBar::Light_Color = S_Borderclass::Outline_Color1;
   ScrollBar::Middle_Color = S_Borderclass::Border_Color;
   ScrollBar::Dark_Color = S_Borderclass::Outline_Color2;
   ScrollBar::Black_Color = makecol(0,0,0);
   if (WHAM)
      WHAM->refresh_all_visible_objects();
      
   if (_s_wham_task_bar)
   {
       clear_to_color(_s_wham_task_bar->bmp(), gui_bg_color);
       _s_wham_task_bar->redraw(gui_fg_color,gui_bg_color);
   }
}

void  s_wham_redraw_desktop()
{
  s_wham_restore_colors();
  WHAM->refresh_all_visible_objects();
}


static int s_wham_process_keys(void *p)
{
	p = NULL; //ignore it
   if (key_shifts & KB_CTRL_FLAG)
   {
   	while(key[KEY_LEFT])
      {
      	WHAM->shift_all(10,0);
         rest(1);
         clear_keybuf();
      }
   	while(key[KEY_RIGHT])
      {
      	WHAM->shift_all(-10,0);
         rest(10);
         clear_keybuf();
      }
   	while(key[KEY_UP])
      {
      	WHAM->shift_all(0,10);
         rest(10);
         clear_keybuf();
      }
   	while(key[KEY_DOWN])
      {
      	WHAM->shift_all(0,-10);
         rest(10);
         clear_keybuf();
      }
   }
   
   int x=mouse_x;
   int y=mouse_y;
	int mx,my;
   get_mouse_mickeys(&mx,&my);
   
   while(mouse_b & 1 && mouse_b & 2)
   {
      get_mouse_mickeys(&mx,&my);

      if (mx || my)
      {
	 		position_mouse(x,y);
	      WHAM->shift_all(-mx,-my);
      }
   }

   
	return 0;
}



int install_s_wham(int card, int w, int h, int virtual_w, int virtual_h,int depth, char *config_file)
{
   char buf1[100],buf2[100];

   if (!_allegro_count)
   {
   	puts("allegro_init not called!\n");
      exit(1);
   }
	_s_wham_font = font;
   if (config_file)
   	set_config_file(config_file);

	if (!w)
   	w = get_config_int("GRAPHICS_MODE","width",800);
	if (!h)
   	h = get_config_int("GRAPHICS_MODE","height",600);
      
   if (!virtual_w)
   	virtual_w = get_config_int("S_WHAMWINDOWS","virtual_screen_height",1600);

   if (!virtual_w)
   	virtual_w = get_config_int("S_WHAMWINDOWS","virtual_screen_height",1600);

 	whamgui_raise_style = get_config_int("S_WHAMWINDOWS","whamgui_raise_style",RAISE_IMMEDIATE);

	virtual_w = MAX(virtual_w,w);
	virtual_h = MAX(virtual_h,h);
      
   if (!depth)
      depth = get_config_int("GRAPHICS_MODE","depth",8);
      
	if (depth)
   	set_color_depth(depth);
   
   install_timer();
   if (set_gfx_mode(card,w,h,0,0))
   {
    	set_gfx_mode(GFX_SAFE,w,h,0,0);
      set_palette(desktop_palette);
      install_mouse();
      sprintf(buf1,"Error entering %dx%d %dbpp graphics mode", w, h, depth);
      sprintf(buf2,"%dx%d %dbpp mode selected instead", SCREEN_W, SCREEN_H, bitmap_color_depth(screen));
   	alert(buf1,allegro_error,buf2,"OK",NULL,13,0);
   }
   set_palette(black_palette);
   install_keyboard();
   install_mouse();


   WinSystem::Buffered = FALSE;
   WinSystem::UseBoxes = TRUE;

   WinSystem::Minimum_Size_x = 43;
   WinSystem::Minimum_Size_y = 0;
   WinSystem::Full_Remove = FALSE;
   
   s_wham_restore_colors();
   
   WHAM = new WinSystem();

   if (!WHAM)
   	out_of_mem("Starting up windowing system.");

   // add a separator, to keep task bar TOP locked
	Wobject * separator = new Top_Bottom_Separator(WHAM);

   if (!separator)
   	out_of_mem("Starting up windowing system.");

   atexit(s_wham_exit);
   ScrollBar::White_Color = makecol(255,255,255);
   ScrollBar::Light_Color = S_Borderclass::Outline_Color1;
   ScrollBar::Middle_Color = S_Borderclass::Border_Color;
   ScrollBar::Dark_Color = S_Borderclass::Outline_Color2;
   ScrollBar::Black_Color = makecol(0,0,0);


   _s_wham_task_bar = new S_TaskBar;

   if (!_s_wham_task_bar)
   	out_of_mem("Starting up windowing system.");

   
	_s_wham_task_bar->show();
   _s_wham_task_bar->set_lock_visibility(TRUE);
   _s_wham_task_bar->raise_and_lock();


   s_wham_root_window = new Background(WinSystem::BackgroundColor);

  if (!s_wham_root_window)
   	out_of_mem("Starting up windowing system.");

   
   s_wham_root_window->show();
   check_cpu();



   if (cpu_family >=5)
   	S_Borderclass::Move_Style = S_BORDERCLASS_OPAQUE;

   s_wham_xor_color = bitmap_color_depth(screen) == 8 ? 255 : makecol(255,255,255);
      


	Wham_Secretary.schedule(s_wham_process_keys,NULL,0);
   WHAM->set_shift_all_range(0,0,virtual_w-w,virtual_h-h);

   wham_menu_draw_border = S_Borderclass::draw_box;

   
   resize = create_bitmap(16,16);
   move = create_bitmap(16,16);
   if (!resize || !move)
   	out_of_mem("Starting up windowing system.");

   fixup_datafile(mousecursor_data);
      
   BITMAP *m = &mousecursor_move;
   BITMAP *r = &mousecursor_resize;
   
   
   int mouse_white = (bitmap_color_depth(screen)==8) ? 255 : makecol(255,255,255);
   int mouse_black = (bitmap_color_depth(screen)==8) ? 16 : makecol(0,0,0);
   int mouse_mask = (bitmap_color_depth(screen)==8) ? 0 : bitmap_mask_color(screen);

   clear_to_color(resize,mouse_mask);
   clear_to_color(move,mouse_mask);

   for (int i=0;i<16;i++)
   	for (int j=0;j<16;j++)
      {
   		switch(getpixel(m,i,j))
         {
         	case 1:
            	putpixel(move,i,j,mouse_black);
            	break;
            case 2:
            	putpixel(move,i,j,mouse_white);
            	break;
            default:
            	break;
         }
   		switch(getpixel(r,i,j))
         {
         	case 1:
            	putpixel(resize,i,j,mouse_black);
            	break;
            case 2:
            	putpixel(resize,i,j,mouse_white);
            	break;
            default:
            	break;
         }
      }
   

	WinSystem::Mouse_Cursor1 = new Mouse_Cursor(move,8,8);
	WinSystem::Mouse_Cursor2 = new Mouse_Cursor(resize,8,8);

   return 0;
}


void s_wham_set_font(FONT *fnt)
{
	_s_wham_font = fnt;
   _s_wham_task_bar->algui_font = fnt;
   WHAM->refresh_all_visible_objects();
}




void s_wham_exit()
{
	destroy_bitmap(resize);
   destroy_bitmap(move);


   delete WinSystem::Mouse_Cursor1;
   delete WinSystem::Mouse_Cursor2;
   
   if (WHAM)
   {
	   delete WHAM;
   }
   WHAM = NULL;
}


char *s_wham_about_string = NULL;
BITMAP *s_wham_about_bitmap = NULL;
Background *s_wham_root_window = NULL;
FONT *_s_wham_font;

MENU *s_wham_user_menu = NULL;



/*
	vline(resize, 0, 0, 5, mouse_black);
	vline(resize, 2, 3, 5, mouse_black);
   putpixel(resize, 1, 5, mouse_black);
   
	vline(resize, 15, 15, 10, mouse_black);
	vline(resize, 13, 12, 10, mouse_black);
   putpixel(resize, 13, 10 ,mouse_black);

	hline(resize, 1, 0, 5, mouse_black);
	hline(resize, 3, 2, 5, mouse_black);
   putpixel(resize, 5, 1, mouse_black);

	hline(resize, 14, 15, 10, mouse_black);
	hline(resize, 12, 13, 10, mouse_black);
   putpixel(resize, 10, 14, mouse_black);

   line(resize, 3, 4, 11, 12, mouse_black);
   line(resize, 4, 3, 12, 11, mouse_black);

   line(resize, 1, 1, 14, 14, mouse_white);
   vline(resize, 1, 2, 4, mouse_white);
   vline(resize, 14, 13, 11, mouse_white);
   hline(resize, 2, 1, 4, mouse_white);
   hline(resize, 13, 14, 11, mouse_white);


   vline(move, 6, 0, 15, mouse_black);
   hline(move, 0, 6, 15, mouse_black);
   vline(move, 7, 0, 15, mouse_black);
   hline(move, 0, 7, 15, mouse_black);
   vline(move, 8, 0, 15, mouse_black);
   hline(move, 0, 8, 15, mouse_black);

   vline(move, 5, 1, 3, mouse_black);
   vline(move, 9, 1, 3, mouse_black);
   vline(move, 5, 14, 12, mouse_black);
   vline(move, 9, 14, 12, mouse_black);
   hline(move, 1, 5, 3, mouse_black);
   hline(move, 1, 9, 3, mouse_black);
   hline(move, 14, 5, 12, mouse_black);
   hline(move, 14, 9, 12, mouse_black);
   
   putpixel(move, 6, 2, mouse_white);
   putpixel(move, 8, 2, mouse_white);
   putpixel(move, 6, 13, mouse_white);
   putpixel(move, 8, 13, mouse_white);

   putpixel(move, 2, 6, mouse_white);
   putpixel(move, 2, 8, mouse_white);
   putpixel(move, 13, 6, mouse_white);
   putpixel(move, 13, 8, mouse_white);

   hline(move, 1, 7, 14, mouse_white);
   vline(move, 7, 1, 14, mouse_white);
*/
